using System;

namespace PolymorphismCSharp
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	/// 
	//Create a person class
	public class Person //Base class 
	{
		public int iAge;
		private string strName; //Attributes
		public string GetName() //Method
		{
			return strName;
		}
		public void SetName(string Name)
		{
			strName=Name;
		}
		public virtual void Play() //Virtual method which can be override in the derived class 
			//for Polymorphism feature
		{
			System.Console.WriteLine("I can play any game");  	
		}
	};
	// Create a class CricketPlayer derived from person
	public class CricketPlayer: Person //derived class
	{
		public string strNationality;//Attribute
		string GetNationality()
		{
			return strNationality;
		}
		public override void Play() //Overriden method from the person class 
		{
			System.Console.WriteLine("I can play Cricket");  	
		}
	};
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: Add code to start application here
			//
			CricketPlayer Player; //derived class object
			Player= new CricketPlayer(); 
			Player.iAge=23;
			Player.SetName("Ricky Ponting");
			Player.strNationality="Australia";
			System.Console.WriteLine("Polymorphism Example");
			System.Console.WriteLine();
			Player.Play(); //calling the derived class play directly
			System.Console.WriteLine();
			Person Person1= new Person();
			Person1.Play(); //Calling the base class play
			System.Console.WriteLine();
			CricketPlayer CricPlayer = new CricketPlayer(); 
			Person Person2=CricPlayer;
			Person2.Play();//Calling the derived class play from base class through polymorphism
			System.Console.WriteLine();
		}
	}
}
